jQuery( document ).ready(
	function ($) {
		if (countries.map_display != 1){
			jQuery('#billing_address_map_map').hide();
			jQuery('#shipping_address_map_map').hide();
		}
		if(countries.map_validation != 1){
			jQuery( document ).on(
				'input',
				".search_input",
				function () {
					jQuery( 'input.find_location' ).val( "false" );
				}
			);
		}
		if(jQuery('#billing_address_1').length){
			$('div#billing_address_map_map, div#shipping_address_map_map').css({
				'height': '420px',
    			'margin-bottom': '60px'
			});
		}
		jQuery('#custom-message').hide();
		jQuery('#custom-message-shiping').hide();
		setTimeout(function() {
			jQuery('#billing_address_map_search_input').val('');
		}, 100);
		address_map                  = ['billing_address_map_map'];
		address_map_s                = ['shipping_address_map_map'];
		var address_search           = ['billing_address_map_search_input'];
		var address_search_shipping   = ['shipping_address_map_search_input'];
		var map_address_data         = jQuery.parseJSON( map_data[0] );
		var billing_shipping_address = [map_address_data.billing_data, map_address_data.shipping_data, map_address_data.location_list];
		var default_country          = woocommerce_default_country.woocommerce_country;
		autocomplete                 = [];
		marker                       = [];
		var custom_zoom_map = Number(countries.custom_zoom_map) || 8;
		if(countries.map_validation != 1){
			$.each(
				address_map,
				function (index, value) {
					if ($( '#' + value ).length > 0) {
						initAutocomplete( value, address_search[index], billing_shipping_address[index], default_country, custom_zoom_map );
						if(jQuery('#shipping_address_map_map').length > 0){
							shippingAutocomplete( address_map_s, address_search_shipping[index], billing_shipping_address[index], default_country, custom_zoom_map);
						}
					}
				}
			);
		}
		jQuery( '#billing_country_field' ).on(
			"change",
			function (e, args){
				jQuery( ".select2-selection" ).removeClass( "select2-selection select2-selection--single" );
			}
		);
		jQuery( '#select2-shipping_country-container' ).on(
			"change",
			function (e, args){
				jQuery( ".select2-selection" ).removeClass( "select2 select2-container select2-container--default select2-container--below" );
			}
		);
	}
);

function addYourLocationButton(map, marker, geocoder, type) {
	var controlDiv = document.createElement( 'div' );

	var firstChild = document.createElement( 'button' );
	firstChild.setAttribute( 'type', 'button' );
	firstChild.style.backgroundColor = '#fff';
	firstChild.style.border          = 'none';
	firstChild.style.outline         = 'none';
	firstChild.style.width           = '40px';
	firstChild.style.height          = '40px';
	firstChild.style.borderRadius    = '2px';
	firstChild.style.boxShadow       = '0 1px 4px rgba(0,0,0,0.3)';
	firstChild.style.cursor          = 'pointer';
	firstChild.style.marginRight     = '10px';
	firstChild.style.padding         = '0px';
	firstChild.title                 = 'Your Location';
	controlDiv.appendChild( firstChild );

	var secondChild                      = document.createElement( 'div' );
	secondChild.style.margin             = '11px';
	secondChild.style.width              = '18px';
	secondChild.style.height             = '18px';
	secondChild.style.backgroundImage    = 'url(https://maps.gstatic.com/tactile/mylocation/mylocation-sprite-1x.png)';
	secondChild.style.backgroundSize     = '';
	secondChild.style.backgroundPosition = '0px 0px';
	secondChild.style.backgroundRepeat   = 'no-repeat';
	secondChild.id                       = 'you_location_img';
	firstChild.appendChild( secondChild );

	google.maps.event.addListener(
		map,
		'dragend',
		function () {
			jQuery( '#you_location_img' ).css( 'background-position', '0px 0px' );
		}
	);

	firstChild.addEventListener(
		'click',
		function () {
			var imgX              = '0';
			var animationInterval = setInterval(
				function () {
					if (imgX == '-18') {
						imgX = '0';
					} else {
						imgX = '-18';
					}
					jQuery( '#you_location_img' ).css( 'background-position', imgX + 'px 0px' );
				},
				500
			);
			if (navigator.geolocation) {
				navigator.geolocation.getCurrentPosition(
					function (position) {
						var latlng = new google.maps.LatLng( position.coords.latitude, position.coords.longitude );
						marker.setPosition( latlng );
						map.setCenter( latlng );
						clearInterval( animationInterval );
						jQuery( '#you_location_img' ).css( 'background-position', '-144px 0px' );
						geocoder.geocode(
							{'latLng': latlng},
							function (results, status) {
								// validate
								if (status != google.maps.GeocoderStatus.OK) {
									return;
								}
								if ( ! results[0]) {
									return;
								}

								var location = results[0];
								var country  = get_map_place( results[0] );
								// set lat , long and address
								if ( type == 'billing' ) {
									update_map_location_fields( map.map_id, position.coords.latitude, position.coords.longitude, location.formatted_address, location.address_components );
									// update billing/shipping address details
									update_billing_shipping_map_place( results[0], 0 );
								} else {
									update_billing_shipping_map_place( results[0], 1 );
								}

							}
						)
					}
				);

			} else {
				clearInterval( animationInterval );
				jQuery( '#you_location_img' ).css( 'background-position', '0px 0px' );
			}
			clearInterval( animationInterval );
		}
	);
	controlDiv.index = 1;
	map.controls[google.maps.ControlPosition.RIGHT_BOTTOM].push( controlDiv );
}
function map_style(map_style) {
    if(map_style == 1) {
        return '[]';
    } else if(map_style == 2) {
        return '[  {    "elementType": "geometry",    "stylers": [      {        "color": "#f5f5f5"      }    ]  },  {    "elementType": "labels.icon",    "stylers": [      {        "visibility": "off"      }    ]  },  {    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#616161"      }    ]  },  {    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#f5f5f5"      }    ]  },  {    "featureType": "administrative.land_parcel",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#bdbdbd"      }    ]  },  {    "featureType": "poi",    "elementType": "geometry",    "stylers": [      {        "color": "#eeeeee"      }    ]  },  {    "featureType": "poi",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#757575"      }    ]  },  {    "featureType": "poi.park",    "elementType": "geometry",    "stylers": [      {        "color": "#e5e5e5"      }    ]  },  {    "featureType": "poi.park",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#9e9e9e"      }    ]  },  {    "featureType": "road",    "elementType": "geometry",    "stylers": [      {        "color": "#ffffff"      }    ]  },  {    "featureType": "road.arterial",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#757575"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry",    "stylers": [      {        "color": "#dadada"      }    ]  },  {    "featureType": "road.highway",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#616161"      }    ]  },  {    "featureType": "road.local",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#9e9e9e"      }    ]  },  {    "featureType": "transit.line",    "elementType": "geometry",    "stylers": [      {        "color": "#e5e5e5"      }    ]  },  {    "featureType": "transit.station",    "elementType": "geometry",    "stylers": [      {        "color": "#eeeeee"      }    ]  },  {    "featureType": "water",    "elementType": "geometry",    "stylers": [      {        "color": "#c9c9c9"      }    ]  },  {    "featureType": "water",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#9e9e9e"      }    ]  }]';
    } else if (map_style == 3){
        return '[        {            "elementType": "geometry",            "stylers": [            {                "color": "#ebe3cd"            }        ]        },        {            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#523735"            }        ]        },        {            "elementType": "labels.text.stroke",            "stylers": [            {                "color": "#f5f1e6"            }        ]        },        {            "featureType": "administrative",            "elementType": "geometry.stroke",            "stylers": [            {                "color": "#c9b2a6"            }        ]        },        {            "featureType": "administrative.land_parcel",            "elementType": "geometry.stroke",            "stylers": [            {                "color": "#dcd2be"            }        ]        },        {            "featureType": "administrative.land_parcel",            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#ae9e90"            }        ]        },        {            "featureType": "landscape.natural",            "elementType": "geometry",            "stylers": [            {                "color": "#dfd2ae"            }        ]        },        {            "featureType": "poi",            "elementType": "geometry",            "stylers": [            {                "color": "#dfd2ae"            }        ]        },        {            "featureType": "poi",            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#93817c"            }        ]        },        {            "featureType": "poi.park",            "elementType": "geometry.fill",            "stylers": [            {                "color": "#a5b076"            }        ]        },        {            "featureType": "poi.park",            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#447530"            }        ]        },        {            "featureType": "road",            "elementType": "geometry",            "stylers": [            {                "color": "#f5f1e6"            }        ]        },        {            "featureType": "road.arterial",            "elementType": "geometry",            "stylers": [            {                "color": "#fdfcf8"            }        ]        },        {            "featureType": "road.highway",            "elementType": "geometry",            "stylers": [            {                "color": "#f8c967"            }        ]        },        {            "featureType": "road.highway",            "elementType": "geometry.stroke",            "stylers": [            {                "color": "#e9bc62"            }        ]        },        {            "featureType": "road.highway.controlled_access",            "elementType": "geometry",            "stylers": [            {                "color": "#e98d58"            }        ]        },        {            "featureType": "road.highway.controlled_access",            "elementType": "geometry.stroke",            "stylers": [            {                "color": "#db8555"            }        ]        },        {            "featureType": "road.local",            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#806b63"            }        ]        },        {            "featureType": "transit.line",            "elementType": "geometry",            "stylers": [            {                "color": "#dfd2ae"            }        ]        },        {            "featureType": "transit.line",            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#8f7d77"            }        ]        },        {            "featureType": "transit.line",            "elementType": "labels.text.stroke",            "stylers": [            {                "color": "#ebe3cd"            }        ]        },        {            "featureType": "transit.station",            "elementType": "geometry",            "stylers": [            {                "color": "#dfd2ae"            }        ]        },        {            "featureType": "water",            "elementType": "geometry.fill",            "stylers": [            {                "color": "#b9d3c2"            }        ]        },        {            "featureType": "water",            "elementType": "labels.text.fill",            "stylers": [            {                "color": "#92998d"            }        ]        }    ]';
    } else if( map_style == 4 ){
        return '[  {    "elementType": "geometry",    "stylers": [      {        "color": "#212121"      }    ]  },  {    "elementType": "labels.icon",    "stylers": [      {        "visibility": "off"      }    ]  },  {    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#757575"      }    ]  },  {    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#212121"      }    ]  },  {    "featureType": "administrative",    "elementType": "geometry",    "stylers": [      {        "color": "#757575"      }    ]  },  {    "featureType": "administrative.country",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#9e9e9e"      }    ]  },  {    "featureType": "administrative.land_parcel",    "stylers": [      {        "visibility": "off"      }    ]  },  {    "featureType": "administrative.locality",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#bdbdbd"      }    ]  },  {    "featureType": "poi",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#757575"      }    ]  },  {    "featureType": "poi.park",    "elementType": "geometry",    "stylers": [      {        "color": "#181818"      }    ]  },  {    "featureType": "poi.park",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#616161"      }    ]  },  {    "featureType": "poi.park",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#1b1b1b"      }    ]  },  {    "featureType": "road",    "elementType": "geometry.fill",    "stylers": [      {        "color": "#2c2c2c"      }    ]  },  {    "featureType": "road",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#8a8a8a"      }    ]  },  {    "featureType": "road.arterial",    "elementType": "geometry",    "stylers": [      {        "color": "#373737"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry",    "stylers": [      {        "color": "#3c3c3c"      }    ]  },  {    "featureType": "road.highway.controlled_access",    "elementType": "geometry",    "stylers": [      {        "color": "#4e4e4e"      }    ]  },  {    "featureType": "road.local",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#616161"      }    ]  },  {    "featureType": "transit",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#757575"      }    ]  },  {    "featureType": "water",    "elementType": "geometry",    "stylers": [      {        "color": "#000000"      }    ]  },  {    "featureType": "water",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#3d3d3d"      }    ]  }]';
    } else if( map_style == 5 ){
        return '[  {    "elementType": "geometry",    "stylers": [      {        "color": "#242f3e"      }    ]  },  {    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#746855"      }    ]  },  {    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#242f3e"      }    ]  },  {    "featureType": "administrative.locality",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#d59563"      }    ]  },  {    "featureType": "poi",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#d59563"      }    ]  },  {    "featureType": "poi.park",    "elementType": "geometry",    "stylers": [      {        "color": "#263c3f"      }    ]  },  {    "featureType": "poi.park",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#6b9a76"      }    ]  },  {    "featureType": "road",    "elementType": "geometry",    "stylers": [      {        "color": "#38414e"      }    ]  },  {    "featureType": "road",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#212a37"      }    ]  },  {    "featureType": "road",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#9ca5b3"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry",    "stylers": [      {        "color": "#746855"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#1f2835"      }    ]  },  {    "featureType": "road.highway",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#f3d19c"      }    ]  },  {    "featureType": "transit",    "elementType": "geometry",    "stylers": [      {        "color": "#2f3948"      }    ]  },  {    "featureType": "transit.station",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#d59563"      }    ]  },  {    "featureType": "water",    "elementType": "geometry",    "stylers": [      {        "color": "#17263c"      }    ]  },  {    "featureType": "water",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#515c6d"      }    ]  },  {    "featureType": "water",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#17263c"      }    ]  }]';
    } else if( map_style == 6 ){
        return '[  {    "elementType": "geometry",    "stylers": [      {        "color": "#1d2c4d"      }    ]  },  {    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#8ec3b9"      }    ]  },  {    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#1a3646"      }    ]  },  {    "featureType": "administrative.country",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#4b6878"      }    ]  },  {    "featureType": "administrative.land_parcel",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#64779e"      }    ]  },  {    "featureType": "administrative.province",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#4b6878"      }    ]  },  {    "featureType": "landscape.man_made",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#334e87"      }    ]  },  {    "featureType": "landscape.natural",    "elementType": "geometry",    "stylers": [      {        "color": "#023e58"      }    ]  },  {    "featureType": "poi",    "elementType": "geometry",    "stylers": [      {        "color": "#283d6a"      }    ]  },  {    "featureType": "poi",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#6f9ba5"      }    ]  },  {    "featureType": "poi",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#1d2c4d"      }    ]  },  {    "featureType": "poi.park",    "elementType": "geometry.fill",    "stylers": [      {        "color": "#023e58"      }    ]  },  {    "featureType": "poi.park",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#3C7680"      }    ]  },  {    "featureType": "road",    "elementType": "geometry",    "stylers": [      {        "color": "#304a7d"      }    ]  },  {    "featureType": "road",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#98a5be"      }    ]  },  {    "featureType": "road",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#1d2c4d"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry",    "stylers": [      {        "color": "#2c6675"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#255763"      }    ]  },  {    "featureType": "road.highway",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#b0d5ce"      }    ]  },  {    "featureType": "road.highway",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#023e58"      }    ]  },  {    "featureType": "transit",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#98a5be"      }    ]  },  {    "featureType": "transit",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#1d2c4d"      }    ]  },  {    "featureType": "transit.line",    "elementType": "geometry.fill",    "stylers": [      {        "color": "#283d6a"      }    ]  },  {    "featureType": "transit.station",    "elementType": "geometry",    "stylers": [      {        "color": "#3a4762"      }    ]  },  {    "featureType": "water",    "elementType": "geometry",    "stylers": [      {        "color": "#0e1626"      }    ]  },  {    "featureType": "water",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#4e6d70"      }    ]  }]';
    } else if( map_style == 7 ){
        return '[  {    "elementType": "geometry",    "stylers": [      {        "color": "#ebe3cd"      }    ]  },  {    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#523735"      }    ]  },  {    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#f5f1e6"      }    ]  },  {    "featureType": "administrative",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#c9b2a6"      }    ]  },  {    "featureType": "administrative.land_parcel",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#dcd2be"      }    ]  },  {    "featureType": "administrative.land_parcel",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#ae9e90"      }    ]  },  {    "featureType": "landscape.natural",    "elementType": "geometry",    "stylers": [      {        "color": "#fefdd3"      }    ]  },  {    "featureType": "poi",    "elementType": "geometry",    "stylers": [      {        "color": "#dfd2ae"      }    ]  },  {    "featureType": "poi",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#93817c"      }    ]  },  {    "featureType": "poi.park",    "elementType": "geometry.fill",    "stylers": [      {        "color": "#a5b076"      }    ]  },  {    "featureType": "poi.park",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#447530"      }    ]  },  {    "featureType": "road",    "elementType": "geometry",    "stylers": [      {        "color": "#f5f1e6"      }    ]  },  {    "featureType": "road.arterial",    "elementType": "geometry",    "stylers": [      {        "color": "#fdfcf8"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry",    "stylers": [      {        "color": "#f8c967"      }    ]  },  {    "featureType": "road.highway",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#e9bc62"      }    ]  },  {    "featureType": "road.highway.controlled_access",    "elementType": "geometry",    "stylers": [      {        "color": "#e98d58"      }    ]  },  {    "featureType": "road.highway.controlled_access",    "elementType": "geometry.stroke",    "stylers": [      {        "color": "#db8555"      }    ]  },  {    "featureType": "road.local",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#806b63"      }    ]  },  {    "featureType": "transit.line",    "elementType": "geometry",    "stylers": [      {        "color": "#dfd2ae"      }    ]  },  {    "featureType": "transit.line",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#8f7d77"      }    ]  },  {    "featureType": "transit.line",    "elementType": "labels.text.stroke",    "stylers": [      {        "color": "#ebe3cd"      }    ]  },  {    "featureType": "transit.station",    "elementType": "geometry",    "stylers": [      {        "color": "#dfd2ae"      }    ]  },  {    "featureType": "water",    "elementType": "geometry.fill",    "stylers": [      {        "color": "#03526b"      }    ]  },  {    "featureType": "water",    "elementType": "labels.text.fill",    "stylers": [      {        "color": "#92998d"      }    ]  }]';
    } else if(map_style == '' || map_style > 7 || map_style < 1) {
        return '[]';
    }
}

function initAutocomplete(map_element, search_input, billing_shipping_address, default_country, custom_zoom_map) {
	// alert(map_element);
	// get map lat , lng and address
	var map_lat = '',
	map_lng     = '';
	var latlng;

	// get user address from billing/shipping user address
	if (billing_shipping_address.lat !== undefined && billing_shipping_address.lng !== undefined && billing_shipping_address.search_input !== undefined) {
		map_lat = parseFloat( billing_shipping_address.lat );
		map_lng = parseFloat( billing_shipping_address.lng );
		// map_country = billing_shipping_address.search_country;
		jQuery( '#' + map_element ).closest( '.form-row' ).find( '.search_input' ).val( billing_shipping_address.search_input );
		jQuery( '#' + map_element ).closest( '.form-row' ).find( '.search_lat' ).val( map_lat );
		jQuery( '#' + map_element ).closest( '.form-row' ).find( '.search_lng' ).val( map_lng );
		jQuery( '#' + map_element ).closest( '.form-row' ).find( '.find_location' ).val( "false" );
	} else {
		// Try HTML5 geolocation.
		infoWindow = new google.maps.InfoWindow();
		if (navigator.geolocation) {
			navigator.geolocation.getCurrentPosition(
				function (position) {
					var pos = {
						lat: position.coords.latitude,
						lng: position.coords.longitude
					};

					latlng = new google.maps.LatLng( pos.lat, pos.lng );
					map.setCenter( pos );
					map_lat = pos.lat;
					map_lng = pos.lng;
					// update marker
					marker[0].setPosition( latlng );
					// show marker
					marker[0].setVisible( true );
					geocoder.geocode(
						{'latLng': latlng},
						function (results, status) {
							// validate
							if (status != google.maps.GeocoderStatus.OK) {
								console.log( 'Geocoder failed due to: ' + status );
								return;
							}
							if ( ! results[0]) {
								console.log( 'No results found' );
								return;
							}

							var location = results[0];
							var country  = get_map_place( results[0] );
							update_map_location_fields( map_element, pos.lat, pos.lng, location.formatted_address, location.address_components  );
							update_billing_shipping_map_place( results[0], 0 );
						}
					);

				},
				function (error) {
					// handleLocationError(true, infoWindow, map.getCenter());
				}
			);
		}
	}
	if ((countries.aafw_enable_map === 1 && countries.enable_restriction === null) || countries.enable_restriction === 1) {
			jQuery('#billing_address_map_search_input').on('keyup', function (e) {
				var enteredAddress = jQuery(this).val(); // Get the entered address from the input field
				var geocoder = new google.maps.Geocoder();
				var map = new google.maps.Map(
					document.getElementById(map_element),
					{
						center: { lat: 1, lng: -1 }, // Default center or your preferred location
						zoom: custom_zoom_map, // Adjust the zoom level as needed
						mapTypeId: 'roadmap',
						streetViewControl: false,
					}
				);
				geocoder.geocode({ address: enteredAddress }, function (results, status) {
					if (status === "OK" && results.length > 0) {
						var location = results[0].geometry.location;
						var marker = new google.maps.Marker({
							position: location,
							map: map,
							title: "Entered Address Marker",
						});
						map.setCenter(location); // Center the map on the marker's location
					} else {
						console.error("Geocoding failed: " + status);
					}
				});
			});
		}
	// old place for map
	var selectedMapStyle = countries.map_style; 

	var mapStyle = map_style(selectedMapStyle);
	var map = new google.maps.Map(
		document.getElementById(map_element),
		{
			center: {lat: 1, lng: -1},
			zoom: custom_zoom_map,
			mapTypeId: 'roadmap',
			streetViewControl: false,
			map_id: map_element,
		}
	);
	map.setOptions({styles: JSON.parse(mapStyle)});
	geocoder = new google.maps.Geocoder();
	if (billing_shipping_address.lat === undefined && billing_shipping_address.lng === undefined && billing_shipping_address.search_input === undefined) {
		geocodeAddress( geocoder, map, default_country );
	}
	marker.push(
		new google.maps.Marker(
			{
				map: map,
				draggable: true,
				animation: google.maps.Animation.DROP,
				position: {lat: 1, lng: -1}
			}
		)
	);
	latlng = new google.maps.LatLng( 1, -1 );
	if (marker.length - 1 != -1) {
		geocoder.geocode(
			{'latLng': latlng},
			function (results, status) {
				if (status != google.maps.GeocoderStatus.OK) {
					console.log( 'Geocoder failed due to: ' + status );
					return;
				}
				if ( ! results[0]) {
					console.log( 'No results found' );
					return;
				}
				var location = results[0];
				var country  = get_map_place( results[0] );
				marker[marker.length - 1].setPosition( latlng );
				marker[marker.length - 1].setVisible( true );
				update_map_location_fields( map_element, map_lat, map_lng, location.formatted_address, location.address_components );
				update_billing_shipping_map_place( results[0], 0 );
			}
		);
	}

	marker[marker.length - 1].addListener(
		'click',
		function (e) {
			toggleBounce( e, jQuery( this ) );
		}
	);
	marker[marker.length - 1].addListener(
		'load',
		function (e) {
			toggleBounce( e, jQuery( this ) );
		}
	);
	marker[marker.length - 1].addListener(
		'dragend',
		function (e) {
			toggleBounce( e, jQuery( this ) );
		}
	);

	var input         = document.getElementById( search_input );
	var defaultBounds = new google.maps.LatLngBounds(
		new google.maps.LatLng( 40.518, 29.215 ),
		new google.maps.LatLng( 41.242, 30.370 )
	);

	let country;
	if (countries.countries.includes( "all" )) {
		country = [];
	} else {
		country = countries.countries;
	}
	const options = {
		bounds: defaultBounds,
		componentRestrictions: { country: country },
		fields: ["address_components", "geometry", "icon", "name"],
		strictBounds: false,
	};
	if ( aafw_enable_restriction.aafw_enable_restriction == 1 && 'all' !== countries.selling_location) {
		autocomplete.push( new google.maps.places.Autocomplete( input, options ) );
	} else {
		 autocomplete.push( new google.maps.places.Autocomplete( input ) );
	}
	autocomplete[autocomplete.length - 1].map = map;
	autocomplete[autocomplete.length - 1].bindTo( 'bounds', map );

	map.addListener(
		'click',
		function (e) {
			changeMarkerCickMap( e, jQuery( this ), marker );
		}
	);
	autocomplete[autocomplete.length - 1].addListener(
		'place_changed',
		function (e) {
			var current_map = jQuery( this )[0].map;
			var map_id      = current_map.map_id;
			var map_index   = address_map.indexOf( map_id );
			if (map_index != -1) {
				var location          = autocomplete[map_index].getPlace();
				var country           = get_map_place( location );
				var lat               = location.geometry.location.lat();
				var lng               = location.geometry.location.lng();
				var latlng            = new google.maps.LatLng( lat, lng );
				var formatted_address = formatAddressComponents(location.address_components, map_data[0]);
				marker[map_index].setPosition( latlng );
				// show marker
				marker[map_index].setVisible( true );
				// set center
				current_map.setCenter( latlng );

				update_map_location_fields( map_id, lat, lng, formatted_address, location.address_components );
				// update billing/shipping address details
				update_billing_shipping_map_place( location, map_index );
			}
		}
	);

	addYourLocationButton( map, marker[marker.length - 1], geocoder, 'billing' );
}

function handleLocationError(browserHasGeolocation, infoWindow, pos) {
	infoWindow.setPosition( pos );
	infoWindow.setContent(
		browserHasGeolocation ?
			'Error: The Geolocation service failed.' :
		'Error: Your browser doesn\'t support geolocation.'
	);
	infoWindow.open( map );
}

function toggleBounce(e, dataMap) {

	var lat        = e.latLng.lat(),
	lng   		   = e.latLng.lng(),
	latlng 		   = new google.maps.LatLng( lat, lng );
	var map_id     = dataMap[0].map.map_id;
	var map_index  = address_map.indexOf( map_id );
	if (map_index != -1) {

		if (marker[map_index].getAnimation() !== null) {
			marker[map_index].setAnimation( null );
		} else {
			marker[map_index].setAnimation( google.maps.Animation.BOUNCE );
		}

		geocoder.geocode(
			{'latLng': latlng},
			function (results, status) {
				if (status != google.maps.GeocoderStatus.OK) {
					console.log( 'Geocoder failed due to: ' + status );
					return;
				}
				if ( ! results[0]) {
					console.log( 'No results found' );
					return;
				}

				var location = results[0];
				var country  = get_map_place( results[0] );
				update_map_location_fields( map_id, lat, lng, location.formatted_address, location.address_components );

				update_billing_shipping_map_place( results[0], map_index );
				if (marker[map_index].getAnimation()) {
					marker[map_index].setAnimation( null );
				}

			}
		);

	}

}

function changeMarkerCickMap(e, dataMap, marker) {
	var lat       = e.latLng.lat(), lng = e.latLng.lng(), latlng = new google.maps.LatLng( lat, lng );
	var map_id    = dataMap[0].map_id;
	var map_index = address_map.indexOf( map_id );
	if (map_index != -1) {
		if (marker[map_index].getAnimation() !== null) {
			marker[map_index].setAnimation( null );
		} else {
			marker[map_index].setAnimation( google.maps.Animation.BOUNCE );
		}
		geocoder.geocode(
			{'latLng': latlng},
			function (results, status) {
				if (status != google.maps.GeocoderStatus.OK) {
					console.log( 'Geocoder failed due to: ' + status );
					return;
				}
				if ( ! results[0]) {
					console.log( 'No results found' );
					return;
				}

				var location = results[0];
				var country  = get_map_place( results[0] );
				// update marker
				marker[map_index].setPosition( latlng );
				// show marker
				marker[map_index].setVisible( true );
				update_map_location_fields( map_id, lat, lng, location.formatted_address, location.address_components );
				// update billing/shipping address details
				update_billing_shipping_map_place( results[0], map_index );
				if (marker[map_index].getAnimation()) {
					marker[map_index].setAnimation( null );
				}
			}
		);
	} else {
		if (marker.getAnimation() !== null) {
			marker.setAnimation( null );
		} else {
			marker.setAnimation( google.maps.Animation.BOUNCE );
		}
		geocoder.geocode(
			{'latLng': latlng},
			function (results, status) {
				if (status != google.maps.GeocoderStatus.OK) {
					console.log( 'Geocoder failed due to: ' + status );
					return;
				}
				if ( ! results[0]) {
					console.log( 'No results found' );
					return;
				}
				var location = results[0];
				// update marker
				marker.setPosition( latlng );
				// show marker
				marker.setVisible( true );
				// update billing/shipping address details
				update_billing_shipping_map_place( results[0], 1 );
				if (marker.getAnimation()) {
					marker.setAnimation( null );
				}

			}
		);
	}

}

function update_map_location_fields(map_id, lat, lng, formatted_address, location_address) {
	jQuery( '#' + map_id ).closest( '.form-row' ).find( '.search_lat' ).val( lat );
	jQuery( '#' + map_id ).closest( '.form-row' ).find( '.search_lng' ).val( lng );
	jQuery( '#' + map_id ).closest( '.form-row' ).find( '.search_input' ).val( formatted_address );
	jQuery( '#' + map_id ).closest( '.form-row' ).find( '.find_location' ).val( "true" );
	var countryObject = location_address.find(obj => obj.types.includes("country"));
	if (countryObject) {
		var countryName = countryObject.short_name;
	}
	
	selectedCountries  = countries.countries;
	enable_restriction  = countries.enable_restriction;

	if(enable_restriction == 1){
		if (selectedCountries.includes(countryName)) {
			jQuery('#custom-message').hide();
		} else {
			jQuery('#custom-message').show();
		}
	}
	jQuery( '#billing_address_1' ).val( formatted_address );
}

function getretunrfromaddress_components(address_components,whtreturn) {
    for (var i = 0; i < address_components.length; i++) {
        if (address_components[i].types.includes(whtreturn)) {
            return address_components[i].long_name;
        }
    }
    return null; 
}

function update_billing_shipping_map_place(location, map_index) {

    var map_form = map_index === 0 ? 'billing_' : 'shipping_';

    var country = getretunrfromaddress_components(location.address_components, 'country');

    var fields, map_location_fields;

    if (country === 'Australia') {
        fields = ['country', 'city', 'state', 'postcode'];
        map_location_fields = ['country', 'locality', 'administrative_area_level_1', 'postal_code'];
    } else {
        fields = ['country', 'city', 'state', 'state2', 'postcode'];
        map_location_fields = ['country', 'locality', 'administrative_area_level_1', 'administrative_area_level_2', 'postal_code'];
    }

    // Set street address
    var streetAddress = jQuery('#' + map_form + 'address_map_search_input').val();
    jQuery('#' + map_form + 'address_1').val(streetAddress);
	
    jQuery.each(map_location_fields, function (index, value) {
        var filtered_array = location.address_components.filter(function (address_component) {
            return address_component.types.includes(value);
        });

        var map_field = '';
        if (filtered_array.length > 0) {
            // Use short_name for country and state fields
            if (value === 'country' || value === 'administrative_area_level_1') {
                map_field = filtered_array[0].short_name;
            } else {
                map_field = filtered_array[0].long_name;
            }
        }
        if (fields[index] === 'country') {
            setTimeout(function () {
                jQuery('#' + map_form + fields[index]).val(map_field).select2().trigger('change');
            }, 500);
        } else if (fields[index] === 'state') {
            // Increase the timeout for the state field to ensure the select field is fully rendered
            setTimeout(function () {
				
                // Manually set the state value using select2
                jQuery('#' + map_form + fields[index]).val(map_field).trigger('change');
				
                // If the value doesn't exist directly, attempt to match by text
                if (jQuery('#' + map_form + fields[index]).val() === '' || jQuery('#' + map_form + fields[index]).val() === null) {
                    jQuery('#' + map_form + fields[index] + ' option').each(function () {
                        var current = jQuery(this);
                        var n = current.text().toLowerCase();
                        var m = map_field.toLowerCase();
                        if (n === m || n.indexOf(m) > -1) {
                            jQuery('#' + map_form + fields[index]).val(current.val()).trigger('change');
                        }
                    });
                }
            }, 2000); // Adjust this timeout value based on your observation of the rendering delay

        } else {
            jQuery('#' + map_form + fields[index]).val(map_field);
        }
		
    });
}

function extractFromAdress(components) {
	
	if (components[0].types.includes( 'locality' )) {
		return components[0].long_name;
	} else {
		for (var i = components.length - 1; i >= 0; i--) {

			for (var j = 0; j < components[i].types.length; j++){
				if (components[i].types[j] == 'administrative_area_level_1') {
					return components[i].short_name;
					break;
				} else if (components[i].types[j] == 'administrative_area_level_2') {
					return components[i].long_name;
					break;
				} else if (components[i].types[j] == 'administrative_area_level_3') {
					return components[i].long_name;
					break;
				} else {
					return "none";
				}
			}
		}
	}
	return "";
}
function get_map_place(location) {
	var filtered_array = location.address_components.filter(
		function (address_component) {
			if (address_component.types.includes( "locality" )) {
				return address_component.types.includes( "locality" );
			} else if (address_component.types.includes( "administrative_area_level_1" )) {
				return address_component.types.includes( "administrative_area_level_1" );
			} else {
				return address_component.types.includes( "country" );
			}
		}
	);
	return filtered_array.length ? filtered_array[0].long_name : "";
}

function geocodeAddress(geocoder, resultsMap, default_country) {
	geocoder.geocode(
		{'address': default_country},
		function (results, status) {
			if (status != google.maps.GeocoderStatus.OK) {
				console.log( 'Geocoder failed due to: ' + status );
				return;
			}
			if ( ! results[0]) {
				console.log( 'No results found' );
				return;
			}

			if (status === 'OK') {
				resultsMap.setCenter( results[0].geometry.location );
				marker[0].setPosition( results[0].geometry.location );
				marker[0].setVisible( true );
			}
		}
	);
}
// shipping
function shippingAutocomplete(map_element, search_input, default_country, billing_shipping_address, custom_zoom_map) {
	let marker, geocoder, infoWindow;
	s_map_element = document.getElementById(map_element);
	var mapStyle = map_style(selectedMapStyle);
	map               = new google.maps.Map(
		s_map_element,
		{
			center: {lat: 1, lng: -1},
			zoom: custom_zoom_map,
			mapTypeId: 'roadmap',
			streetViewControl: false,
			map_id: map_element,
		}
	);
	var s_input = document.getElementById( 'shipping_address_map_search_input' );
	let country;
	if (countries.countries.includes( "all" )) {
		country = [];
	} else {
		country = countries.countries;
	}

	var defaultBounds = new google.maps.LatLngBounds(
		new google.maps.LatLng( 40.518, 29.215 ),
		new google.maps.LatLng( 41.242, 30.370 )
	);
	const options     = {
		bounds: defaultBounds,
		componentRestrictions: { country: country },
		fields: ["address_components", "geometry", "icon", "name"],
		strictBounds: false,
	};
	if ( aafw_enable_restriction.aafw_enable_restriction == 1 && 'all' !== countries.selling_location) {
		var s_autocomplete = new google.maps.places.Autocomplete( s_input, options );
	} else {
		var s_autocomplete = new google.maps.places.Autocomplete( s_input );
	}
	var map_element_field = "shipping_address_map";
	s_autocomplete.addListener(
		'place_changed',
		function (e) {
			var address_object = s_autocomplete.getPlace();
			var lat            = address_object.geometry.location.lat();
			var lng            = address_object.geometry.location.lng();
			var latlng         = new google.maps.LatLng( lat, lng );
			if (marker) {
				marker.setPosition(latlng);
				marker.setVisible(true);
			} else {
				console.log("Marker is not defined.");
			}
			map.setCenter( latlng );
			var formatted_address = formatAddressComponents(address_object.address_components, map_data[0]);
			update_shipping_map_location_fields( map_element_field, lat, lng, address_object, formatted_address);
			update_billing_shipping_map_place( address_object, 1 );
		}
	);

	var map_lat = '', map_lng = '', map_address = '';
	let latlng;
	
	if (billing_shipping_address.lat !== undefined && billing_shipping_address.lng !== undefined && billing_shipping_address.search_input !== undefined) {
		map_lat = parseFloat( billing_shipping_address.lat );
		map_lng = parseFloat( billing_shipping_address.lng );
		latlng  = new google.maps.LatLng( map_lat, map_lng );
		var pos = {
			lat: map_lat,
			lng: map_lng
		};
		shipping_map_dragend( map_lat, map_lng, latlng, pos );

		jQuery( '#' + map_element_field + 'search_input' ).closest( '.form-row' ).find( '.search_input' ).val( billing_shipping_address.search_input );
		jQuery( '#' + map_element_field + 'search_lat' ).closest( '.form-row' ).find( '.search_lat' ).val( map_lat );
		jQuery( '#' + map_element_field + 'search_lng' ).closest( '.form-row' ).find( '.search_lng' ).val( map_lng );
		jQuery( '#' + map_element_field + 'find_location' ).closest( '.form-row' ).find( '.find_location' ).val( "false" );
	} else {
		// Try HTML5 geolocation.
		infoWindow = new google.maps.InfoWindow();
		var slat   = 36.241384;
		var slng   = -113.7547193;
		latlng     = new google.maps.LatLng( slat, slng );
		map_lat    = slat;
		map_lng    = slng;
		var pos    = {
			lat: map_lat,
			lng: map_lng
		};
	}
	var selectedMapStyle = countries.map_style; 

	var mapStyle = map_style(selectedMapStyle);
	map               = new google.maps.Map(
		s_map_element,
		{
			center: {lat: latlng.lat(), lng: latlng.lng()},
			zoom: custom_zoom_map,
			mapTypeId: 'roadmap',
			streetViewControl: false,
			map_id: map_element,
		}
	);
	map.setOptions({styles: JSON.parse(mapStyle)});
	map.setCenter( pos );

	marker = new google.maps.Marker(
		{
			position: latlng,
			map: map,
			draggable: true,
			animation: google.maps.Animation.DROP,
		}
	);

	map.addListener(
		'click',
		function (e) {
			changeMarkerCickMap( e, jQuery( this ), marker );
		}
	);
	geocoder = new google.maps.Geocoder();
	marker.addListener(
		'click',
		function (e) {
			shippingToggleBounce( marker );
		}
	);
	marker.addListener(
		'load',
		function (e) {
			shippingToggleBounce( marker );
		}
	);
	google.maps.event.addListener(
		marker,
		'dragend',
		function(e) {
			shippingToggleBounce( marker );
			var lat = e.latLng.lat(),
			lng     = e.latLng.lng(),
			latlng  = new google.maps.LatLng( lat, lng );
			geocoder.geocode(
				{
					latLng: marker.getPosition()
				},
				function(responses, status) {
					if (status == google.maps.GeocoderStatus.OK) {
						if ( responses[0] ) {
							var s_address_comp = responses[0];
							var s_city         = get_map_place( s_address_comp );
							var formatted_address = formatAddressComponents(s_address_comp.address_components, map_data[0]);
							update_shipping_map_location_fields( map_element_field, lat, lng, formatted_address, responses );
							update_billing_shipping_map_place( s_address_comp, 1 );
						}
					}
				}
			);
		}
	);
	addYourLocationButton( map, marker, geocoder, 'shipping' )
}
function formatAddressComponents(addressComponents, mapData) {
    var formattedAddr = '';
    var fieldSettings = jQuery.parseJSON(mapData).fieldsettings;

    // Check if all field settings are empty
    var allSettingsEmpty = true;
    jQuery.each(fieldSettings, function(key, value) {
        if (value !== '') {
            allSettingsEmpty = false;
            return false; // Exit loop early if a non-empty setting is found
        }
    });

    // If all settings are empty, return the original addressComponents
    if (allSettingsEmpty) {
        jQuery.each(addressComponents, function(index, value) {
			if (value.types.includes("premise")) {
                formattedAddr += value.long_name + '/'; 
            }
			
			if (value.types.includes("subpremise")) {
                formattedAddr += value.long_name + '/'; 
            }
			
			if (value.types.includes("street_number")) {
				formattedAddr += value.long_name + ' ';
			}

			if (value.types.includes("route")) {
				formattedAddr += value.short_name + ' ';
			}
			
			if (value.types.includes("sublocality")) {
				formattedAddr += value.short_name.toUpperCase() + ' '; 
			}
			
			if (value.types.includes("locality")) {
				formattedAddr += value.short_name.toUpperCase() + ' '; 
			}
			
			if (value.types.includes("administrative_area_level_3")) {
				formattedAddr += value.short_name.toUpperCase() + ' ';
			}

			if (value.types.includes("administrative_area_level_1")) {
				formattedAddr += value.short_name.toUpperCase() + ' '; 
			}

			if (value.types.includes("administrative_area_level_2")) {
				formattedAddr += value.short_name + ' ';
			}

			if (value.types.includes("neighborhood")) {
				formattedAddr += value.short_name + ' ';
			}

			if (value.types.includes("country")) {
				formattedAddr += value.short_name + ' ';
			}

			if (value.types.includes("postal_code")) {
				formattedAddr += value.long_name + ' ';
			}
		});
      return formattedAddr.trim(); // Trim any trailing spaces
    }
	
    // Proceed with formatting if at least one setting is enabled
    jQuery.each(addressComponents, function(index, value) {
		if (fieldSettings.street_numberrouteaddr && value.types.includes("subpremise")) {
            formattedAddr += value.long_name + '/';
        }
		
		if (fieldSettings.street_numberrouteaddr && value.types.includes("premise")) {
            formattedAddr += value.long_name + '/'; 
        }
		
        if (fieldSettings.street_numberrouteaddr && value.types.includes("street_number")) {
            formattedAddr += value.long_name + ' ';
        }

        if (fieldSettings.routeaddr && value.types.includes("route")) {
            formattedAddr += value.short_name + ' ';
        }

        if (fieldSettings.localityaddr && value.types.includes("locality")) {
            formattedAddr += value.short_name.toUpperCase() + ' '; 
        }
		
		if (fieldSettings.localityaddr && value.types.includes("sublocality")) {
            formattedAddr += value.short_name.toUpperCase() + ' '; 
        }
		
		if (fieldSettings.administrative_area_level_1addr && value.types.includes("administrative_area_level_3")) {
            formattedAddr += value.short_name.toUpperCase() + ' '; 
        }
		
        if (fieldSettings.administrative_area_level_1addr && value.types.includes("administrative_area_level_1")) {
            formattedAddr += value.short_name.toUpperCase() + ' '; 
        }

        if (fieldSettings.administrative_area_level_2addr && value.types.includes("administrative_area_level_2")) {
            formattedAddr += value.short_name + ' ';
        }

        if (fieldSettings.neighborhoodaddr && value.types.includes("neighborhood")) {
            formattedAddr += value.short_name + ' ';
        }

        if (fieldSettings.Countryaddr && value.types.includes("country")) {
            formattedAddr += value.short_name + ' ';
        }

        if (fieldSettings.Postalcc && value.types.includes("postal_code")) {
            formattedAddr += value.long_name + ' ';
        }
    });
    return formattedAddr.trim(); // Trim any trailing spaces
}
function update_shipping_map_location_fields(map_id, lat, lng, shipping_location_address, formatted_address) {
	jQuery( '#' + map_id + 'search_lat' ).closest( '.form-row' ).find( '.search_lat' ).val( lat );
	jQuery( '#' + map_id + 'search_lng' ).closest( '.form-row' ).find( '.search_lng' ).val( lng );
	jQuery( '#' + map_id + 'find_location' ).closest( '.form-row' ).find( '.find_location' ).val( "true" );

	jQuery( '#shipping_address_1' ).val( formatted_address );
	jQuery('#shipping_address_map_search_input').val(formatted_address);
	if(shipping_location_address){
		var countryObject = shipping_location_address.address_components.find(obj => obj.types.includes("country"));
		if (countryObject) {
			var countryShortName = countryObject.short_name;
			var countryName = countryShortName;
		}
		selectedCountries  = countries.countries;
		enable_restriction  = countries.enable_restriction;
		if(enable_restriction == 1){
			if (selectedCountries.includes(countryName)) {
				jQuery('#custom-message-shiping').hide();
			} else {
				jQuery('#custom-message-shiping').show();
			}
		}
	}
	if(map_id == 'shipping_address_map'){
		jQuery('#shipping_address_map_search_input').val(formatted_address);
		
	} else {
		jQuery('#billing_address_map_search_input').val(formatted_address);
	}
}


function shippingToggleBounce(marker) {
	if (marker.getAnimation() !== null) {
		marker.setAnimation( null );
	} else {
		marker.setAnimation( google.maps.Animation.BOUNCE );
	}
	setTimeout(
		function() {
			marker.setAnimation( null );
		},
		3000
	);
}